/*
* Licensed to the Apache Software Foundation (ASF) under one or more
* contributor license agreements.  See the NOTICE file distributed with
* this work for additional information regarding copyright ownership.
* The ASF licenses this file to You under the Apache License, Version 2.0
* (the "License"); you may not use this file except in compliance with
* the License.  You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/
import java.io.File;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.openrdf.OpenRDFException;
import org.openrdf.query.QueryLanguage;
import org.openrdf.query.TupleQuery;
import org.openrdf.query.TupleQueryResult;
import org.openrdf.repository.Repository;
import org.openrdf.repository.RepositoryConnection;
import org.openrdf.repository.RepositoryException;
import org.openrdf.repository.sail.SailRepository;
import org.openrdf.rio.RDFFormat;
import org.openrdf.sail.memory.MemoryStore;
import org.openrdf.sail.nativerdf.NativeStore;
import java.net.URL;


public class Hello extends HttpServlet {

    private static final long serialVersionUID = 1L;

    @Override
    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {
    	
    	

    	
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();
    	
    	
        File dataDir = new File("/Users/caracciolo/Projects/QualitasCorpus/20120401/apache-tomcat-7.0.28/data/");
    	Repository myRepository = new SailRepository(new NativeStore(dataDir));     
    	

    	try {
    		   myRepository.initialize();
    		   RepositoryConnection con = myRepository.getConnection();
    		   try {
    		      String queryString = "PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>" +
    		      		"PREFIX som:<http://www.ifi.unizh.ch/ddis/evoont/2008/02/som#>"+
    		      		" SELECT ?x  WHERE {?x rdf:type som:Method ; }";
    		      TupleQuery tupleQuery = con.prepareTupleQuery(QueryLanguage.SPARQL, queryString);
    		      TupleQueryResult result = tupleQuery.evaluate();
    		      try {
    		    	  while(result.hasNext()){
        		    	  out.println(result.next().getValue("x")+"<br>");
    		    	  }
    		      } finally {
    		         result.close();
    		         out.println("closed");
    		      }
    		   }  finally {
    		      con.close();
 		         out.println("closed");
 		         this.deleteDir(new File("/Users/caracciolo/Projects/QualitasCorpus/20120401/apache-tomcat-7.0.28/data/lock"));
    		   }
    		} catch (OpenRDFException e) {
    		   String s = e.getMessage();
    		   out.println(s);
    		}
    	
    	
    	
    	



    }
    
    
    public boolean deleteDir(File dir) {
        if (dir.isDirectory()) {
            String[] children = dir.list();
            for (int i=0; i<children.length; i++) {
                boolean success = deleteDir(new File(dir, children[i]));
                if (!success) {
                    return false;
                }
            }
        }

        // The directory is now empty so delete it
        return dir.delete();
    }
}


